unit Unit1;
{
https://forum.lazarus.freepascal.org/index.php/topic,57957.0.html
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  ComCtrls;

type
  Tproc = procedure (sender: tobject);
  TMyRec = record
    cap : string;
    clk : Tproc;
  end;
  TMyArray = array of TMyRec;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    procedure Button1Click(Sender: TObject);
  private

  public
    procedure NewClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure CutClick(Sender: TObject);
    procedure CopyClick(Sender: TObject);
    procedure PasteClick(Sender: TObject);

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}


{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);

var
  tools : TMyArray = ( (cap:'New'; clk:@NewClick),
                       (cap:'Save';clk:@SaveClick) );
//                                     ^^^^^^^^ does NOT work

  procedure AddButtons(ToolBar: TToolBar; const ButtonCaptions: array of String);
  // from https://lazarus-ccr.sourceforge.io/docs/lcl/comctrls/ttoolbar.buttons.html
  var
    i: integer;
  begin
    for i := 0 to High(ButtonCaptions) do
    begin
      with TToolButton.Create(ToolBar) do
      begin
        Parent := ToolBar;
        Caption := ButtonCaptions[i];
        if (ButtonCaptions[i] = '|') then
          Style := tbsSeparator
        else
          Style := tbsButton;
        AutoSize := True;
        left := parent.width;
        onclick := @NewClick;
      end;
    end;
  end;
begin
  AddButtons(ToolBar1, ['New', 'Save', '|', 'Cut', 'Copy', 'Paste']);
  memo1.append(IntToStr(ToolBar1.ButtonCount));
end;

procedure TForm1.NewClick(Sender: TObject);
begin
  memo1.append('New');
end;
procedure TForm1.SaveClick(Sender: TObject);
begin
  memo1.append('Save');
end;
procedure TForm1.CutClick(Sender: TObject);
begin
  memo1.append('Cut');
end;
procedure TForm1.CopyClick(Sender: TObject);
begin
  memo1.append('Copy');
end;
procedure TForm1.PasteClick(Sender: TObject);
begin
  memo1.append('Paste');
end;

end.

